#ifndef COMMON_GLOBAL_H
#define COMMON_GLOBAL_H

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include "dlfcn.h"

#include <arpa/inet.h>


extern int errno ;

//*****************************************************************
//*     Maros
//*****************************************************************

#define TRUE                            1
#define FALSE                           0

#define STS_IDLE                        0
#define STS_ALLOCATED           1
#define STS_OK                          0
#define STS_NG                          -1
#define STS_RUN                         2
#define STS_ERROR                       3
#define STS_KILLREQ                     4

#define LOG_NORML                       0,__FILE__,__LINE__
#define LOG_ERROR                       1,__FILE__,__LINE__

//*****************************************************************
//*    structure
//*****************************************************************

typedef struct
{
	char	ast_host[1024] ;
	char	ast_port[1024] ;
	char	tim_sleep[1024] ;
	char	fil_config[1024] ;
	char	dir_target[1024] ;
	char	dir_destination[1024] ;
	char	dir_primary[1024] ;
	char	dir_secondary[1024] ;
	char	dir_archive[1024] ;
	char	dir_workdir[1024] ;
	char	dir_logdir[1024] ;
	char	fil_destination[1024] ;
	char	fil_target[1024] ;
	char	fil_check1[1024] ;
	char	fil_check2[1024] ;
	char	fil_catalog[1024] ;
	char	ftp_server[1024] ;
	char	ftp_user[1024] ;
	char	ftp_pass[1024] ;
	char	ftp_destination[1024] ;
	char	tim_duration[1024] ;
	char	post_run[1024] ;
	char	proc_name_01[1024] ;
	char	proc_name_02[1024] ;
	char	proc_name_03[1024] ;
	char	proc_name_04[1024] ;
	char	proc_name_05[1024] ;
	char	fil_name[1024] ;
	char	set_option_01[1024] ;
	char	set_option_02[1024] ;
	char	set_option_03[1024] ;
	char	set_option_04[1024] ;
	char	set_option_05[1024] ;
	char	set_option_06[1024] ;
	char	set_option_07[1024] ;
	char	set_option_08[1024] ;
	char	set_option_09[1024] ;
	char	set_option_10[1024] ;
	char	del_method[1024];
	char	min_size[1024] ;
	char	total_cell[1024] ;
	char	output_order[1024] ;
} CONFIG_INFO_T ;

//*****************************************************************
//*     Function Prototype
//*****************************************************************

int sub_rename_file(char *src, char *dst);
int file_rename(char *src, char *dst);
int sub_token_punkt( char *src, int pos, char *dst, int siz_dst);
int sub_token( char *src, int pos, char *dst, int siz_dst);
int sub_move_file(char *src_fil, char *dst_fil);
int sub_move_file_with_timestamp(char *src_fil, char *dst_dir, char *dst_filnam, char *tgtnam, int tgtsiz);
int sub_copy_file(char *src, char *dst);
int sub_copy_file2dir(char *src_fil, char *dst_dir);
int sub_strip_enter(char *src);
int sub_copy_filecat(char *filnam, char *dirnam);
int sub_tokenize( char *filbuf, char *nambuf, int nambufsiz, int *filsiz, int *filtim );
int sub_make_catalog_file_bysize(char *src, char *dst, char *categ);
int sub_make_catalog_file_bytime(char *src, char *dst, char *categ,int duration);
int sub_strdate(char *s_curtim, int n_maxsiz);
int sub_strtime(char *s_curtim, int n_maxsiz);
int sub_strdatetime(char *s_curtim, int n_maxsiz);
void sub_logname( char *dirnam, char *logname );
void sub_logput ( int ntyp, char *fnam, int nline, char *fmt, ...);
int sub_ftp_command( char *ip_addr, char *usr, char *pass, char *ope, char *remote_path, char *remote_fil, char *local_path, char  *local_file);
int sub_read_args(CONFIG_INFO_T *pftpt, int nargc, char *pargv[]);
int sub_read_config(CONFIG_INFO_T *pftpt);
int sub_check_file(char *dir_check, char *stat_file);
void sub_signal( int nsig );
int sub_scan_procs(char *s_procnam);
int sub_usr1_received();
void sub_exit_on_usr1();

int sub_connect_asterisk(char *ip_address, int nport);
int sub_terminate_sock(int nsoc);
int sub_recv_wait( int cs, int sec );
int sub_recv(int cs, char *rcvbuf, int nremain);
int sub_send(int cs, char *sndbuf, int nremain);
int sub_strip_all_enter(char *src);


#endif
