// *** ================================================================ ***
// ***  Quick Start Server
// ***  --------------------------------------------------------------
// ***  Program Created by Stars System K.K. Tokyo Japan
// ***  Project Lead by Marubeni Information Systems Tokyo Japan
// ***  All rights reserved.
// ***  --------------------------------------------------------------
// ***  UNIX SERVER
// *** ================================================================ ***

#include "common.h"

#define	DEFAULT_LOG_NAME	"/tmp/access_%d.log"

char global_log_name[1024] ;

void sub_logname( char *dirnam, char *logname ) 
{
	char	s_tmp[1024] ;
	char	s_nam[1024] ;

	if ( strlen(dirnam) < 1 )
	{
		memset( global_log_name, 0, sizeof(global_log_name) ) ;
		return ;
	}

	sub_strdate(s_tmp, sizeof(s_tmp)) ;
	sprintf( s_nam, logname, s_tmp ) ;

	strcpy( global_log_name, dirnam ) ;
	strcat( global_log_name, "/" ) ;
	strcat( global_log_name, s_nam ) ;
}

void sub_logput ( int ntyp, char *fnam, int nline, char *fmt, ...)
{
	va_list ap;
	FILE	*fp ;
	char	filbuf[512] ;
	char	dspbuf[1024*8] ;
	char	fncnam[512] ;
	char	*pt ;
	struct tm *tmp ;
	time_t	t ;
	char	lognam[512] ;

	if ( strlen( global_log_name ) < 1 )
	{
		return ;
	}

	/*** ----------------------------------------------------- ***
	 ***	Strip Function Name
	 *** ----------------------------------------------------- ***/

	if ( (pt = strrchr( fnam, '\\' )) != NULL )
	{
		pt++ ;
		strcpy( fncnam, pt ) ;
	} else {
		if ( (pt = strrchr( fnam, '/' )) != NULL )
		{
			pt++ ;
			strcpy( fncnam, pt ) ;
		} else {
			strcpy( fncnam, fnam ) ;
		}
	}

	/*** ----------------------------------------------------- ***
	 ***	Logging Start
	 *** ----------------------------------------------------- ***/

	if ( (fp = fopen( global_log_name, "a+" )) == NULL )
	{
		return ; 
	}

	/*** ----------------------------------------------------- ***
	 ***	Time Stamp
	 *** ----------------------------------------------------- ***/

	time(&t) ;
	tmp = (struct tm *)localtime(&t) ;
	strftime( filbuf, sizeof(filbuf), "%Y/%m/%d %H:%M:%S", tmp ) ;

	/*** ----------------------------------------------------- ***
	 ***	Arguments
	 *** ----------------------------------------------------- ***/

    va_start(ap, fmt);
	vsnprintf(dspbuf, sizeof(dspbuf), fmt, ap ) ;
    va_end(ap);

	/*** ----------------------------------------------------- ***
	 ***	Log Type
	 *** ----------------------------------------------------- ***/

	switch( ntyp )
	{
	case 0:		
		strcpy( lognam, "NORMAL" ) ;		
		break ;
	case 1:	
		strcpy( lognam, " ERROR" ) ;		
		break ;
	case 2:	
		strcpy( lognam, " TRACE" ) ;		
		break ;
	default:    
		strcpy( lognam, "------" ) ;		
		break ;
	}

	/*** ----------------------------------------------------- ***
	 ***	Logging
	 *** ----------------------------------------------------- ***/

	fprintf( fp, "%s [D] (%20.20s:%04d) %s %04d : %s\n", filbuf,fncnam,nline,lognam, getpid(), dspbuf ) ;
	fprintf( stderr, "%s [D] (%20.20s:%04d) %s %04d : %s\n", filbuf,fncnam,nline,lognam, getpid(), dspbuf ) ;

	fclose( fp ) ;

	return ;
}

