#include "common.h"


int sub_send(int cs, char *sndbuf, int nremain)
{
	char	*dp ;
	int		nlen, nsize ;

	nsize = nremain ;
	dp    = sndbuf ;
	while(nremain > 0) 
	{
		nlen = send( cs, dp, nremain, 0) ;
		if (nlen < 0) {
			return -1 ;
		}
		dp += nlen;
		nremain -= nlen;
	}
	return 0 ;
}


int sub_recv(int cs, char *rcvbuf, int nremain)
{
	char	*dp ;
	int	nsize, nlen ;

	nsize = nremain ;
	dp    = rcvbuf ;
	memset( rcvbuf, 0, nremain ) ;

	while(nremain > 0) 
	{
		nlen = recv( cs, dp, nremain , 0) ;

		if (nlen == 0) 
		{
			return -1 ;
		}
		else if (nlen < 0) 
		{
			sub_logput( LOG_ERROR, "nlen=%d, error = %d", nlen, errno ) ;
			return -1 ;
		}
		dp      += nlen;
		nremain -= nlen;
	}
	return 0 ;
}



int sub_recv_wait( int cs, int sec )
{
	int				nsts ;
	fd_set			f1, f2, f3 ;
	struct timeval	tv ;

	FD_ZERO( &f1 ) ;
	FD_ZERO( &f2 ) ;
	FD_ZERO( &f3 ) ;

	FD_SET ( cs, &f1 ) ;
	tv.tv_sec  = sec ;
	tv.tv_usec = 0   ;

	nsts = select( 64, &f1, &f2, &f3, &tv ) ;

	if ( nsts < 0 || FD_ISSET( cs, &f3 ) )
	{
		sub_logput( LOG_ERROR, "Server Thread : Select Error (%d:%d)", nsts, errno) ;
		return -1 ;
	}

	if ( nsts == 0 )
	{
		return -2 ;
	}

	return 0 ;
}


int sub_connect_asterisk(char *ip_address, int nport)
{
    int sock ;
    struct sockaddr_in sock_addr ;

    // create socket
    if( (sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP) ) == -1 )
    {
        return -1 ;
    }

    memset(&sock_addr, 0x00, sizeof(sock_addr) ) ;
    sock_addr.sin_family = AF_INET ;
    sock_addr.sin_port   = htons( nport ) ;

    // set aserisk server's ip address
    if( inet_aton(ip_address, &sock_addr.sin_addr) == 0 )
    {
        return -2 ;
    }

    // connect asterisk server
    if( connect(sock, (struct sockaddr *)&sock_addr, sizeof(sock_addr) ) == -1 )
    {
        return -3 ;
    }

	return sock ;
}

int sub_terminate_sock(int nsoc)
{
	close(nsoc);

	return 0 ;
}



